Bug 1949207 (CVE-2021-28878) - CVE-2021-28878 rust: memory safety violation in Zip implementation when next_back() and next() are used together
Summary: CVE-2021-28878 rust: memory safety violation in Zip implementation when next_...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2021-28878
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1949208 1949209 1953007 1953008 1959105 1967940
Blocks: 1949215
TreeView+ depends on / blocked
 
Reported: 2021-04-13 17:34 UTC by Guilherme de Almeida Suckevicz
Modified: 2022-04-17 21:18 UTC (History)
10 users (show)

Fixed In Version: rust 1.52.0
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-08-10 13:28:30 UTC


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2021:3042 0 None None None 2021-08-10 07:26:11 UTC
Red Hat Product Errata RHSA-2021:3063 0 None None None 2021-08-10 13:51:35 UTC

Description Guilherme de Almeida Suckevicz 2021-04-13 17:34:44 UTC
In the standard library in Rust before 1.52.0, the Zip implementation calls __iterator_get_unchecked() more than once for the same index (under certain conditions) when next_back() and next() are used together. This bug could lead to a memory safety violation due to an unmet safety requirement for the TrustedRandomAccess trait.

Reference:
https://github.com/rust-lang/rust/issues/82291

Upstream patch:
https://github.com/rust-lang/rust/pull/82292

Comment 1 Guilherme de Almeida Suckevicz 2021-04-13 17:35:06 UTC
Created rust tracking bugs for this issue:

Affects: epel-7 [bug 1949209]
Affects: fedora-all [bug 1949208]

Comment 3 errata-xmlrpc 2021-08-10 07:26:09 UTC
This issue has been addressed in the following products:

  Red Hat Developer Tools

Via RHSA-2021:3042 https://access.redhat.com/errata/RHSA-2021:3042

Comment 4 Product Security DevOps Team 2021-08-10 13:28:30 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2021-28878

Comment 5 errata-xmlrpc 2021-08-10 13:51:33 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2021:3063 https://access.redhat.com/errata/RHSA-2021:3063


Note You need to log in before you can comment on or make changes to this bug.